/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of the copyright holder not be used in advertising or publicity
 * pertaining to distribution of the software without specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 *
 * $Id: acconfig.h,v 1.22 2000/11/18 16:13:53 erik Rel $
 ********************************************************************************************************************************/

#ifndef _XZX_CONFIG_H
#define _XZX_CONFIG_H

/*********************************************************************************************************************************
 * General configuration
 ********************************************************************************************************************************/

/* Defines the package name. */
#define PACKAGE			"noname"

/* Defines the version number. */
#define VERSION			"0.0.0"

/* Defines the build date. */
#define DATE			"00/00/00"

/* Defines the host, where the program should run. */
#define HOST			"unknown"

/* Compile without assert() calls. */
#undef NDEBUG

/* The file z80.c contains the code for the emulation of the Z80, which itself is a huge switch statement. With optimizations
   turned on, CC needs a huge amount of memory in order to compile/optimize this code. Undefine this if you run out of swap
   space. */
#define HAVE_ENOUGH_SWAP

/*********************************************************************************************************************************
 * Configuration valid for both shareware and registered version
 ********************************************************************************************************************************/

/* Define this for Pentagon emulation support. */
#define XZX_PENTAGON

/* Define this for Scorpion emulation support. */
#define XZX_SCORPION

/* Define this for Scorpion emulation support. */
#define XZX_DIDAKTIK

/* Define this for Interface I and Microdrive support. */
#define XZX_IF1

/* How many microrives are there (1-8)? */
#define IF1_DRIVES		2

/* Define this for Multiface 128/3 support.  You need an image of the MultifaceROM. The built-in debugger is a good replacement
   for the Multiface, so you should not have any reason to turn the emulation on. */
#define XZX_MF

/* Define this for Kempston mouse support. At the moment only used from the Pentagon and Scorpion emulation. */
#define XZX_KMOUSE

/* Audio support (automatically adjusted by 'configure').
   Choose the audio support type you want.  You must not combine XBELL_AUDIO with REAL_AUDIO. */

/* Emulate speaker and AY chip via /dev/dsp or /dev/audio. */
#undef REAL_AUDIO

/* Emulate ROM beeps only via X server bell (most platforms). */
#undef XBELL_AUDIO

/* Joystick support (automatically adjusted by 'configure').
   You need Linux/FreeBSD with a joystick driver. */
#undef JOY

/* Define this to connect I/O ports to stdin, stdout & stderr. */
#undef PSEUDO_IO


/*********************************************************************************************************************************
 * Configuration valid for the sharware version only
 ********************************************************************************************************************************/


/*********************************************************************************************************************************
 * Configuration valid for the registered version only
 ********************************************************************************************************************************/

/* Define this for Beta 128 emulation support. */
#define XZX_TRDOS

/* Define this for +D emulation support. */
#define XZX_MGT

/* Printer support.
   Choose the printer support type you want. */

/* Emulate ZX printer (not supported yet) */
#define ZX_PRINTER

/* Emulate Interface I printer (not supported yet) */
#define IF1_PRINTER

/* Emulate +3 centronics printer */
#define PLUS3_PRINTER


/*********************************************************************************************************************************
 * Do not change anything below this line
 ********************************************************************************************************************************/

/* Define this if Xlib has the MITSHM extension. */
#undef HAVE_MITSHM

/* Define this if program can query MITSHM extension. */
#undef HAVE_SHMQUERY

/* Define this if the Xpm library is available. */
#undef HAVE_XPM

/* Define this if the Xm library is available. */
#undef HAVE_MOTIF

/* Path relative to /usr/include for header file soundcard.h. */
#undef SOUNDCARD_H_PATH

/* Path relative to /usr/include for header file joystick.h. */
#undef JOYSTICK_H_PATH

/* Define this if NAS is used for the sound emulation. */
#undef NAS_AUDIO

/* Define this if OSS is used for the sound emulation. */
#undef OSS_AUDIO

/* Define this if ALSA is used for the sound emulation. */
#undef ALSA_AUDIO

/* Define this on IRIX machines if the alXXX functions are available. */
#undef HAVE_al_FUNCS

/* Define this on HP-UX machines if the Alib functions are available. */
#undef HAVE_Alib_FUNCS

@TOP@
@BOTTOM@

#include "config2.h"

#endif /* ! _XZX_CONFIG_H */

/* EOF **************************************************************************************************************************/
