/*********************************************************************************************************************************
 * Copyright (c) Des Herriott 1993 - 1994
 *               Erik Kunze   1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of the copyright holder not be used in advertising or publicity
 * pertaining to distribution of the software without specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Authors: Des Herriott
 *          Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif
#ifndef lint
static char rcsid[] = "$Id: dat.c,v 1.1 2000/07/13 15:14:10 erik Rel $";
#endif
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/param.h>
#include "cpu.h"
#include "debug.h"
#include "resource.h"
#include "mem.h"
#include "machine.h"
#include "util.h"
#include "ui.h"
#include "dat.h"
#ifdef DEBUG
#define DEB(x)							{ if ((CFGGET(debug) & D_SNAP) != 0) { x } }
#else
#define DEB(x)
#endif
int
DatReadLevel(char *fname)
{
	int types[2] = { FT_DAT, FT_END };
	FILE *fp;
	char name[MAXPATHLEN], *ptr;
	int addr, ch;
	(void)strcpy(name, fname);
	if ((ptr = strrchr(name, '.')) == (char *)0)
	{
		ptr = name + strlen(name);
	}
	(void)sprintf(ptr, "%d.dat", A);
	if ((fp = Fopen(name,"rb")) == (FILE *)0)
	{
		(void)sprintf(ptr, "%d.DAT", A);
		if ((fp = Fopen(name,"rb")) == (FILE *)0)
		{
			if ((ptr = UiFileSelector("Load Level", 1, types)) != (char *)0)
			{
				(void)strcpy(name, ptr);
				fp = Fopen(ptr, "rb");
				free(ptr);
			}
			if (ptr == (char *)0 || fp == (FILE *)0)
			{
				Msg(M_WARN, "couldn't find level <%s>", name);
				return -1;
			}
		}
	}
	DEB(Msg(M_DEBUG, "reading overlay <%s> at address <%04x>", name, HL););
	for (addr = HL; addr < 65536; addr++)
	{
		if ((ch = fgetc(fp)) == EOF)
		{
			break;
		}
		MEM(addr) = (uns8)ch;
	}
	(void)fclose(fp);
	return 0;
}
