/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of the copyright holder not be used in advertising or publicity
 * pertaining to distribution of the software without specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 *
 * $Id: kmouse.h,v 1.7 2000/11/04 18:54:57 erik Rel $
 ********************************************************************************************************************************/
#ifndef _XZX_KMOUSE_H
#define _XZX_KMOUSE_H
#include <X11/Xlib.h>
#include <X11/Intrinsic.h>
#include "resource.h"
#include "io.h"
#define INBYTE_KMOUSE(port,res,label) \
	{																															\
		if (CFGGET(kmouse) > 0 && ((port) & B_KMOUSE) == (P_KMOUSE & B_KMOUSE))													\
		{																														\
			switch ((port) & 0xff00)																							\
			{																													\
				case P_KMOUSEB & 0xff00:																						\
					(res) = KmouseButtons;																						\
					goto label;																									\
																																\
				case P_KMOUSEX & 0xff00:																						\
					(res) = KmouseX;																							\
					goto label;																									\
																																\
				case P_KMOUSEY & 0xff00:																						\
					(res) = KmouseY;																							\
					goto label;																									\
			}																													\
		}																														\
	}
extern void KmouseInit(void);
extern void KmouseOn(void);
extern void KmouseOff(void);
extern uns8 KmouseX, KmouseY, KmouseButtons;
#endif
