/********************************************************************************
 * Copyright (c) Des Herriott 1993, 1994
 *               Erik Kunze   1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation
 * for any purpose is hereby granted without fee, provided that the above
 * copyright notice appear in all copies and that both that copyright notice and
 * this permission notice appear in supporting documentation, and that the name
 * of the copyright holder not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission.  The
 * copyright holder makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Authors: Des Herriott
 *          Erik Kunze
 *******************************************************************************/
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif
#ifndef lint
static char rcsid[] = "$Id: mem.c,v 4.36 2000/01/07 20:31:19 erik Rel $";
#endif
#include <stdio.h>
#include "util.h"
#include "mem.h"
int RealPageNumbers[8];
uns8 *TheMemory[8];
uns8 *RealMemory[NPAGES];
void
MemoryInit(void)
{
	int i;
	for (i = 0; i < NPAGES; i++)
	{
		RealMemory[i] = (uns8 *)Malloc(XZX_PAGESIZE, "MemoryInit");
	}
}
int
LoadRomImage(char *image, int page, int num)
{
	FILE *ifp;
	size_t nread;
	if (!(ifp = Fopen(image, "rb")))
	{
		Msg(M_PERR, "couldn't open ROM image <%s> for reading", image);
		return -1;
	}
	while (num--)
	{
		nread = fread(RealMemory[page++], 1, XZX_PAGESIZE, ifp);
		if (nread != XZX_PAGESIZE && nread != XZX_PAGESIZE / 2)
		{
			Msg(M_WARN, "ROM image <%s> is too short", image);
			break;
		}
	}
	(void)fclose(ifp);
	return 0;
}
int
GetRomChecksum(int rom, int length)
{
	int checksum = 0, tmp, i;
	for (i = 0; i < length; i++)
	{
		tmp = checksum & 0x01;
		checksum >>= 1;
		if (tmp)
		{
			checksum |= 0x8000;
		}
		checksum ^= RealMemory[rom][i];
	}
	return checksum;
}
