/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of the copyright holder not be used in advertising or publicity
 * pertaining to distribution of the software without specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif
#ifdef XZX_MF
#ifndef lint
static char rcsid[] = "$Id: multiface.c,v 1.5 2000/09/09 09:35:05 erik Rel $";
#endif
#include "resource.h"
#include "mem.h"
#include "util.h"
#include "multiface.h"
int Multiface3Paged;
void
MultifaceInit(void)
{
	int checksum;
	if (!LoadRomImage(CFGGET(mf128Rom), MF128ROM, 1))
	{
		checksum = GetRomChecksum(MF128ROM, XZX_PAGESIZE / 2);
		switch (checksum)
		{
			case 46066:
				break;
			default:
				Msg(M_WARN, "unknown Multiface 128 ROM image - checksum %u",
					checksum);
				break;
		}
	}
	else
	{
		Msg(M_INFO, "MF128 emulation disabled");
		CFGSET(mf128, 0);
	}
	if (!LoadRomImage(CFGGET(mf3Rom), MF3ROM, 1))
	{
		checksum = GetRomChecksum(MF3ROM, XZX_PAGESIZE / 2);
		switch (checksum)
		{
			case 46694:
				break;
			default:
				Msg(M_WARN, "unknown Multiface 3 ROM image - checksum %u",
					checksum);
				break;
		}
	}
	else
	{
		Msg(M_INFO, "MF3 emulation disabled");
		CFGSET(mf3, 0);
	}
}
#endif
