/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of the copyright holder not be used in advertising or publicity
 * pertaining to distribution of the software without specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 *
 * $Id: multiface.h,v 1.5 2000/09/09 09:35:51 erik Rel $
 ********************************************************************************************************************************/
#ifndef _XZX_MULTIFACE_H
#define _XZX_MULTIFACE_H
#include "cpu.h"
#include "resource.h"
#include "mem.h"
#include "io.h"
#include "machine.h"
#define INBYTE_MF1(port,res,label) \
	{																															\
		if (CFGGET(mf1) > 0)																									\
		{																														\
			if (LOWBYTE((port)) == P_MF128OUT && RPAGE(0) == MF128ROM)															\
			{																													\
												\
				Machine->pageIn(0, SP48ROM);																					\
																																\
																\
				(res) = 0xff;																									\
				goto label;																										\
			}																													\
			else if (LOWBYTE((port)) == P_MF128IN)																				\
			{																													\
							\
				Machine->pageIn(0, MF128ROM);																					\
																																\
					\
				(res) = Last0x7FFD & B_SELSCREEN ? 0xff : 0x7f;																	\
				goto label;																										\
			}																													\
		}																														\
	}
#define INBYTE_MF128(port,res,label) \
	{																															\
		if (CFGGET(mf1) > 0)																									\
		{																														\
			if (LOWBYTE((port)) == P_MF128OUT && RPAGE(0) == MF128ROM)															\
			{																													\
												\
				Machine->pageIn(0, SP128ROM0 + ((Last0x7FFD & B_SELROM) >> 4));													\
																																\
																\
				(res) = 0xff;																									\
				goto label;																										\
			}																													\
			else if (LOWBYTE((port)) == P_MF128IN)																				\
			{																													\
							\
				Machine->pageIn(0, MF128ROM);																					\
																																\
					\
				(res) = Last0x7FFD & B_SELSCREEN ? 0xff : 0x7f;																	\
				goto label;																										\
			}																													\
		}																														\
	}
#define INBYTE_MF3(port,res,label) \
	{																															\
		if (CFGGET(mf1) > 0)																									\
		{																														\
			if (LOWBYTE((port)) == P_MF3OUT && Multiface3Paged)																	\
			{																													\
				if (!EXTENDED_RAM(Last0x1FFD))																					\
				{																												\
					Machine->pageIn(0, SP3ROM0 + (((Last0x7FFD & B_SELROM) >> 4) | ((Last0x1FFD & B_SELROM3) >> 1)));			\
				}																												\
				Multiface3Paged = 0;																							\
			}																													\
			else if (LOWBYTE((port)) == P_MF3IN)																				\
			{																													\
				if (!Multiface3Paged)																							\
				{																												\
					if (!EXTENDED_RAM(Last0x1FFD))																				\
					{																											\
						Machine->pageIn(0, MF3ROM);																				\
					}																											\
					Multiface3Paged = 1;																						\
				}																												\
																																\
				if ((port) == P_MF3P7FFD)																						\
				{																												\
					(res) = Last0x7FFD;																							\
					goto label;																									\
				}																												\
				else if ((port) == P_MF3P1FFD)																					\
				{																												\
					(res) = Last0x1FFD;																							\
					goto label;																									\
				}																												\
			}																													\
		}																														\
	}
extern void MultifaceInit(void);
extern int Multiface3Paged;
#endif
