/********************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation
 * for any purpose is hereby granted without fee, provided that the above
 * copyright notice appear in all copies and that both that copyright notice and
 * this permission notice appear in supporting documentation, and that the name
 * of the copyright holder not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission.  The
 * copyright holder makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 *
 * $Id: trdos.h,v 1.14 2000/11/04 21:09:01 erik Rel $
 *******************************************************************************/
#ifndef _XZX_TRDOS_H
#define _XZX_TRDOS_H
#include "resource.h"
#include "mem.h"
#include "machine.h"
#define CHECK_TRDOS(pc) \
	{																		\
		if (CFGGET(trdos) > 0)												\
		{																	\
			if (pc >= 0x4000)												\
			{																\
				if (RPAGE(0) == TRDOSROM)									\
				{															\
					Machine->pageIn(0, Machine->basicRom);					\
				}															\
			}																\
			else if ((pc & 0xff00) == 0x3d00)								\
			{																\
				if (RPAGE(0) == Machine->basicRom)							\
				{															\
					Machine->pageIn(0, TRDOSROM);							\
				}															\
			}																\
		}																	\
	}
#define OUTBYTE_TRDOS(port, val) \
	{																		\
		if (RPAGE(0) == TRDOSROM)											\
		{																	\
			TrdosOutByte(port, val);										\
		}																	\
	}
#define INBYTE_TRDOS(port,res,label) \
	{																		\
		if (RPAGE(0) == TRDOSROM											\
			&& ((port) & 0x1f) == 0x1f										\
			&& (((port) & 0x80) == 0x00 || ((port) & 0xf0) == 0xf0))		\
		{																	\
			(res) = TrdosInByte(port);										\
			goto label;														\
		}																	\
	}
extern void TrdosInit(void);
extern void TrdosReset(void);
extern int TrdosInsertDisk(int);
extern void TrdosEjectDisk(int);
extern char *TrdosDiskName(int);
extern void TrdosOutByte(uns16, uns8);
extern uns8 TrdosInByte(uns16);
#endif
