/********************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation
 * for any purpose is hereby granted without fee, provided that the above
 * copyright notice appear in all copies and that both that copyright notice and
 * this permission notice appear in supporting documentation, and that the name
 * of the copyright holder not be used in advertising or publicity pertaining to
 * distribution of the software without specific, written prior permission.  The
 * copyright holder makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,
 * INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO
 * EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR
 * CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE,
 * DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER
 * TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
 * PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 *
 * $Id: audio.h,v 1.10 2000/01/26 20:06:03 erik Rel $
 *******************************************************************************/
#ifndef _XZX_AUDIO_H
#define _XZX_AUDIO_H
#include <sys/types.h>
#include "beep.h"
#include "speaker.h"
#include "ay8912.h"
enum { AUC_INIT,
	   AUC_ON, AUC_OFF,
	   AUC_SUSPEND, AUC_RESUME };
enum { AUV_SP, AUV_AY };
typedef struct _audioSettings {
	unsigned int active:1;
	unsigned int spVol;
	unsigned char *spBuf;
	unsigned int ayVol;
	unsigned char *ayBuf;
	unsigned int sampleRate;
	unsigned int stereo:1;
	unsigned int tstatesPerSample;
	unsigned int samplesPerFrame;
} AudioSettings;
extern void AudioInit(void);
extern void AudioControl(int);
extern void AudioSetVolume(int, unsigned int);
extern unsigned int AudioGetVolume(int);
extern void AudioPlayBuffer(void);
extern AudioSettings Audio;
extern int OsdOpenAudioDevice(char *, int *, int *);
extern void OsdCloseAudioDevice(void);
extern int OsdDrainAudioDevice(void);
extern size_t OsdGetAudioFreespace(void);
extern size_t OsdPlayAudioBuffer(unsigned char *, size_t);
#endif
