/*********************************************************************************************************************************
 * Copyright (c) Erik Kunze 1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of the copyright holder not be used in advertising or publicity
 * pertaining to distribution of the software without specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Author: Erik Kunze
 ********************************************************************************************************************************/
#ifdef HAVE_CONFIG_H
# include "config.h"
#endif
#ifdef HAVE_XPM
#ifndef lint
static char rcsid[] = "$Id: kbd.c,v 1.11 2000/11/04 18:26:52 erik Rel $";
#endif
#include <Xm/Xm.h>
#include <X11/xpm.h>
#include <Xm/Form.h>
#include <Xm/LabelG.h>
#include <Xm/ToggleBG.h>
#include <assert.h>
#include "util.h"
#include "xwin.h"
#include "kbd.h"
#include "kbd.xpm"
#define XtNull 							(XtPointer)0
#define XtAddCallback(w,cb,f,val)		XtAddCallback(w,cb,f,(XtPointer)(val))
static void kbdCallback(Widget , XtPointer , XtPointer);
static Widget kbdShell = (Widget)0;
void
KbdShow(Widget w)
{
	if (kbdShell == (Widget)0)
	{
		Widget label;
		XmString title;
		Arg arg[7];
		Cardinal i;
		XpmAttributes attr;
		Pixmap pic;
		XwinData *xdp = &XwinDatas;
		int error;
		attr.valuemask = XpmVisual | XpmColormap | XpmDepth;
		XtVaGetValues(xdp->topLevel,
					  XtNdepth, &attr.depth,
					  XtNvisual, &attr.visual,
					  XtNcolormap, &attr.colormap,
					  XtNull);
		error = XpmCreatePixmapFromData(XtDisplay(xdp->topLevel), XtWindow(xdp->topLevel), (char **)kbd_xpm, &pic,
										(Pixmap *)0, &attr);
		XpmFreeAttributes(&attr);
		if (error != 0)
		{
			Msg(M_ERR, XpmGetErrorString(error));
			XmToggleButtonGadgetSetState(w, False, False);
			return;
		}
		title = XmStringCreateLtoR((char *)"XZX Keyboard", XmFONTLIST_DEFAULT_TAG);
		i = 0;
		XtSetArg(arg[i], XmNmarginWidth,     0      ); i++;
		XtSetArg(arg[i], XmNmarginHeight,    0      ); i++;
		XtSetArg(arg[i], XmNshadowThickness, 0      ); i++;
		XtSetArg(arg[i], XmNnoResize,        True   ); i++;
		XtSetArg(arg[i], XmNautoUnmanage,    False  ); i++;
		XtSetArg(arg[i], XmNdeleteResponse,  XmUNMAP); i++;
		XtSetArg(arg[i], XmNdialogTitle,     title  ); i++;
		assert(i <= XtNumber(arg));
		kbdShell = XmCreateFormDialog(xdp->topLevel, (char *)"fd", arg, i);
		XtAddCallback(kbdShell, XmNunmapCallback, kbdCallback, w);
		XmStringFree(title);
		i = 0;
		XtSetArg(arg[i], XmNlabelType,   XmPIXMAP); i++;
		XtSetArg(arg[i], XmNlabelPixmap, pic     ); i++;
		assert(i <= XtNumber(arg));
		label = XmCreateLabelGadget(kbdShell, (char *)"label", arg, i);
		XtManageChild(label);
	}
	XtManageChild(kbdShell);
	XtPopup(XtParent(kbdShell), XtGrabNone);
}
void
KbdHide(Widget w)
{
	XtUnmanageChild(kbdShell);
	XtPopdown(XtParent(kbdShell));
}
static void
kbdCallback(Widget w, XtPointer client, XtPointer call)
{
	XmToggleButtonGadgetSetState((Widget)client, False, False);
}
#endif
