/*********************************************************************************************************************************
 * Copyright (c) Des Herriott 1993 - 1994
 *               Erik Kunze   1995 - 2000
 *
 * Permission to use, distribute, and sell this software and its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that both that copyright notice and this permission notice
 * appear in supporting documentation, and that the name of the copyright holder not be used in advertising or publicity
 * pertaining to distribution of the software without specific, written prior permission.  The copyright holder makes no
 * representations about the suitability of this software for any purpose.  It is provided "as is" without express or implied
 * warranty. THE CODE MAY NOT BE MODIFIED OR REUSED WITHOUT PERMISSION!
 *
 * THE COPYRIGHT HOLDER DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL THE COPYRIGHT HOLDER BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL
 * DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 * OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 * Authors: Des Herriott
 *          Erik Kunze
 *
 * $Id: screen.h,v 4.17 2000/11/18 19:01:17 erik Rel $
 ********************************************************************************************************************************/
#ifndef _XZX_SCREEN_H
#define _XZX_SCREEN_H
#define DFILE							16384
#define	ROWS							24U
#define	COLS							32U
#define	PIXEL_LENGTH					(ROWS * COLS * 8U)
#define	ATTR_LENGTH						(ROWS * COLS)
#define	ATTR_OFFSET						PIXEL_LENGTH
#define	FLASH							0x80
#define	BRIGHT							0x40
#define	PAPER							0x38
#define	INK								0x07
enum { BLACK, BLUE, RED, MAGENTA, GREEN, CYAN, YELLOW, WHITE,
	   BRIGHT_BLACK, BRIGHT_BLUE, BRIGHT_RED, BRIGHT_MAGENTA, BRIGHT_GREEN, BRIGHT_CYAN, BRIGHT_YELLOW, BRIGHT_WHITE,
	   NCOLORS };
extern void ScreenCreateTables(void);
extern void ScreenDestroyTables(void);
extern void ScreenMarkDirty(uns16);
extern void ScreenMarkDirtyAll(void);
extern void ScreenDoFlashing(void);
extern void ScreenSetBorder(uns8);
extern void ScreenRefresh(void);
extern void (*ScreenUpdateLine)(unsigned int);
#endif
